/* Problem URL: https://codeforces.com/contest/2140/problem/C */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        vl fds(n);
        cin >> fds;

        if (n == 1) {
            cout << fds[0] << '\n';
            continue;
        }

        ll total = 0;
        rep(i, n) {
            if (i & 1) {
                total -= fds[i];
            } else {
                total += fds[i];
            }
        }

        vl vet;
        rep(i, n) {
            if (i & 1) {
                vet.push_back(fds[i] * 2);
            }
        }

        int now = 1;
        repv(i, vet) {
            i += now;
            now += 2;
        }

        int size = vet.size();

        while (__builtin_popcount(vet.size()) != 1) {
            vet.push_back(0);
        }

        vl seg(vet.size() * 2);
        vl lazy(vet.size() * 2);

        rep(i, vet.size()) {
            seg[i + vet.size()] = vet[i];
        }

        for (int i = vet.size() - 1; i > 0; i--) {
            seg[i] = max(seg[i * 2], seg[i * 2 + 1]);
        }

        auto propagate = [&](int i) {
            if (lazy[i] == 0) {
                return;
            }

            if (i >= vet.size()) {
                seg[i] += lazy[i];
                lazy[i] = 0;
                return;
            }
            
            seg[i] += lazy[i];
            lazy[i * 2] += lazy[i];
            lazy[i * 2 + 1] += lazy[i];
            lazy[i] = 0;
        };

        function<void(int, int, int, int, int, ll)> update = [&](int i, int l, int r, int tl, int tr, ll v) {
            propagate(i);
            if (l > tr || r < tl) {
                return;
            }

            if (l >= tl && r <= tr) {
                lazy[i] += v;
                propagate(i);
                return;
            }

            int mid = (l + r) >> 1;

            update(i * 2, l, mid, tl, tr, v);
            update(i * 2 + 1, mid + 1, r, tl, tr, v);

            seg[i] = max(seg[i * 2], seg[i * 2 + 1]);
        };

        function<ll(int, int, int, int, int)> query = [&](int i, int l, int r, int tl, int tr) {
            propagate(i);
            if (l > tr || r < tl) {
                return 0LL;
            }

            if (l >= tl && r <= tr) {
                return seg[i];
            }

            int mid = (l + r) >> 1;

            return max(query(i * 2, l, mid, tl, tr), query(i * 2 + 1, mid + 1, r, tl, tr));
        };

        ll ans = 0;

        int ind = 0;
        for (int i = 0; i < n; i += 2) {
            ll tmp = query(1, 0, vet.size() - 1, 0, size - 1);

            rmax(ans, tmp - fds[i] * 2);

            update(1, 0, vet.size() - 1, 0, ind - 1, 2);
            update(1, 0, vet.size() - 1, ind + 1, size - 1, -2);
            ind++;
        }

        int tmp = n;
        if (tmp % 2 == 0) {
            tmp--;
        }

        cout << max(ans + total, total + tmp - 1) << '\n';
    }
}
